#include "buttonnode.h"
#include "buttonshape.h"
#include "backgroundnode.h"

#include <iostream>

#include "scene/scenetree.h"

#include "SparrowInput/input.h"

#include "SparrowRenderer/sparrowrenderer.h"
#include "SparrowRenderer/mesh.h"
#include "SparrowRenderer/phongmaterial.h"

#include "sparrowshell/sparrowshell.h"
#include "tools/font.h"
#include "resourcemanager.h"

ButtonNode::ButtonNode(glm::vec2 position,ButtonShape* shape):
    m_position(position),m_shape(shape)
{
    addChild(m_shape->getBackGround());
}

MeshNode* ButtonNode::getBackGround()
{
    return m_shape->getBackGround();
}

void ButtonNode::update()
{
    GraphicalContainerNode::update();
    Input* input = getEngine().getInput();

    glm::vec2 pos = input->getPosition();;

    if(m_label_updated){
        if(m_label_node)
            removeChild(m_label_node);
        Font* font = RESOURCE_GET(Font,"shellfont");
        std::wstring ws;
        ws.assign(m_label.begin(),m_label.end());
        m_label_node = font->getTextNode(ws,m_label_color,32);
        addChild(m_label_node);
        m_label_position = m_shape->getDimension()/glm::vec2(2,2) - m_label_node->getDimension()/glm::vec2(2,2);

        m_label_node->moveTo2D(m_label_position);
        getEngine().getScene()->updateShaders();
        m_label_updated = false;
    }

    for (auto action : input->getActions())
    {
        if (action == m_action){
            if (m_shape->hover(m_position,pos))
                m_callback->exec();
        }
    }
}

glm::vec2 ButtonNode::getDimension(){
    return m_shape->getDimension();
}
