#ifndef BUTTONNODE_H
#define BUTTONNODE_H

#include "scene/meshnode.h"
#include "scene/graphicalcontainernode.h"
#include "scene/gui/callback.h"
#include "scene/textnode.h"

class ButtonShape;
class BackGroundNode;

class ButtonNode : public GraphicalContainerNode
{
    int m_action;
    glm::vec2 m_position;
    ButtonShape* m_shape;
    CallBack* m_callback;

    std::string m_label;
    bool m_label_updated;
    TextNode* m_label_node;
    glm::vec2 m_label_position;
    glm::vec3 m_label_color;

public:
    ButtonNode(glm::vec2 m_position, ButtonShape* shape);
    MeshNode* getBackGround();
    glm::vec2 getDimension();
    void setCallBack(CallBack* callback){m_callback=callback;}
    void setAction(int action){m_action=action;}
    void setLabel(std::string label){m_label = label; m_label_updated = true;}
    void setLabelColor(glm::vec3 color){m_label_color=color;}
    void update();
};

#endif // BUTTONNODE_H
