#ifndef TEXTNODE_H
#define TEXTNODE_H

#include "meshnode.h"

class TextNode : public MeshNode
{
private:
    std::wstring m_string;
    float m_fontSize;
    glm::vec2 m_dimension;
public:
    TextNode(Mesh* mesh,std::wstring s,float fontSize,bool visible = true) : MeshNode(mesh,visible),m_string(s),m_fontSize(fontSize) {}

    void setDimension(glm::vec2 dim){m_dimension = dim;}
    glm::vec2 getDimension(){return m_dimension;}

    float getFontSize(){return m_fontSize;}
    std::wstring getString(){return m_string;}
};

#endif // TEXTNODE_H
